TurboGears Changelog
====================

1.0.3.2 (July 20, 2007):
------------------------
*Changes*

*Features*

*Fixes*
	* Ticket #1444: Genshi, while internally calling it "variable_lookup", has
	a Buffet Engine plugin that expects "lookup_errors". TG 1.0 and 1.1 look
	for and pass through only "variable_lookup", while TG 1.1 has
	"lookup_errors" in configuration.
	This helps in error handling with Genshi templates.
	Patch by Neil Blakey-Milner.

	* r3318: Output format must not be set for other templating engines than
	Kid, and needs not be set for Kid either. Removed unnecessary imports.
	Christoph Zwerschke.

	* r3317: tg-admin toolbox did not run outside a project directory.
	Christoph Zwerschke.

*Contributors*

Neil Blakey-Milner, Christoph Zwerschke

1.0.3 (July 19, 2007):
-----------------------

*Changes*

* Added support for multiple databases using SA. #1380 by Ian Charnas.

*Features*
*Project Updates*

	* Elixir quickstart by FredLin

	* Adding encryption on the fly for SA identity on in the template as
	  per discussion here:
	  http://groups.google.co.in/group/turbogears/browse_thread/thread/f4b43e9f148c3a9a
	  fixes ticket #1415

	* Added slovenian translation thanks to mte on ticket #1190.

	* Japanese Calendar ticket #1395 thanks to tmatsuo

	* Handle locales in egg creation thanks to Christoph Zwerschke

*Fixes*
	* ticket #1434. Now handles SA Query in addition of SelectResults
      which will be deprecated in the near future.
	
	* ticket #1325  Fix visit entries created more than once in the
	  database.

	* Fixed toolbox config loading during startup.

	* Applied patch from Simon Wittber on ticket #1284: Safari Unicode fix

	* Fix for i18n for testsuites not run in the same directory as the project

	* Patch for ticket #1319: @paginate barfs if you try to sort
	  on a column whose data is generated from SQL. thanks to Alastair

	* Patch from ticket 1318: @paginate doesn't support SQLAlchemy
	  list properties. thanks to alastair!

	* Fixes ticket #1321: Fixed paginate href. Thanks to alastair!

	* Enable custom: plugins outside TG source tree thx to aalbrecht
	  fixes ticket #1178

*Project Updates*
   * recommended version of Python is now 2.5

*Contributors*

Simon Wittber, Christopher Arndt, Christoph Zwerschke, Paul Johnston, FredLin,
jtate, Ian Charnas, Alastair Houghton, Ian Charnas, Alberto Valverde Gonzales,
, Florent Aide.

1.0.2 (May 2, 2007):
-----------------------

*Changes*

* New ``visit.cookie.secure``config option to send cookie only over a secure connection.
  #1375 by James E. Blair.
* ``cherrypy.request`` is now available at the variables sent to every template.
  #1362 by Christoph Zwerschke.
* SA transaction object is now stored at ``cherrypy.request.sa_transaction`` so it
  can be accessed from the controllers. Patch at #1359 by Janzert.
* SecureResource now raises an AttributeError when no require attribute is
  present in the controller class or in the config file. Closes #1336.
  (Note: This might break some "broken" apps, fortunately a detailed exception
   is raised advising how to fix it).
* slight quickstart css modification for tables
* Add default css to highlight the validation error
* make 'flash' block dynamic in quickstart
* session setting is moved to config/app.cfg
* command/toolbox info could list the toolbox plugins 
* Enhancement SQLAlchemy default model, use 'assign' to avoid repeatedly writing, thanks cito
* Able to specify a default doctype in genshi, thanks Alastair Houghton

*Features*

* Validators now support localized error messages. Thanks to Gregor Horvath and updated patch
  at #1136 by Christian Vogler.
* Python 2.5 compatible, Thanks to Florent Aide and Fred Lin #1288
* AutoCompleteField now accepts a take_focus parameter to focus on load. Thanks to Grover at #1332

*Fixes*

* Fixed support for SA in paginate. #1360 by Jo Soares.
* Schemas are no longer deepcopied to prevent crashing on un-deep-copiable validators. #1333.
* Fixed bug in tg-admin that caused it not to operate properly on projects deployed as eggs. Patch
  from #1361 by Christoph Zwerschke.
* SA auto-commiting fixed in some rare circumstances where sa_rwt was not being called. Patch from 
  #1267 by Paul Johnston.
* CatWalk now handles customized addRemoveName in SO. #911 by Joost 
* using base64.decodestring in visitor.py for 2.3 compatibility. #1279 by Paul Fisher.
* Config file in quickstarted app now has config option to load identity classes. Thanks to Felix
  Schwarz #1255.
* Identity now supports encrypted passwords with unicode characters. Thanks to Felix Schwarz and
  Patrick Lewis #1281 
* minor changes to template so they work properly when server.webpath != / thanks to "nludban" #1213
* fix quickstart project tests, thanks to Christoph Zwerschke #1289, Jeff Kowalczyk #1219
* fix TurboGears 1.0.1 not installable with python2.3, thanks to "corvus" #1264
* Automatic creation of identity model tables for SQLAlchemy, thanks to Christoph Zwerschke #1290
* fix DateTimeConverter, thanks to iberonesia #1262
* ModelDesigner? now write up-to-date model header
* decouple turbogears.identity.encrypt_password() from sqlobject
* remove class_mapper dependency from #1292, thanks chrisz

*Project Updates*

* ez_setup.py version to 0.6c5
* Not require cElementTree, pysqlite in Python 2.5 install
* FormEncode version to i18n aware 0.7.1
* RuleDispatch to 0.5a0.dev-r2303 for Python 2.5 support.
* Added requirement of DecoratorTools due to upgrade of PyProtocols which 
  deprecates functions used in decorator.py.

*Contributors*

Alberto Valverde, Fred Lin, Jorge Vargas, Joseph Tate, Elvelind Grandin, Florent Aide, nludban, Jeff Kowalczyk, corvus, Christoph Zwerschke, iberonesia, Alastair Houghton, Felix Schwartz, Patrcik Lewis, Grover, Paul Fisher, Joost Moesker, Paul Johnston, Christian Vogler, Janzert, Chris Miles, Christopher Arndt, Jo Soares, James E. Blair.


1.0.1 (January 22, 2007):
-------------------------

*Changes*

* paginate decorator now supports SA, improves sorting and fixes problems
  with CompoundWidget. Thanks to randall@tnr.cc and sbr77. #2404
* Catwalk now supports SQLMultipleJoin/SQLRelatedJoins. Thanks to Chris Arndt 
  #2382
* more docstring for widgets package #2355

*Fixes*


* Identity logout  now works properly when using ``set_identity_user`` #1245.
  Thanks to Felix Schwarz
* set right default encoding 'utf-8' instead of 'utf8' which broke 
  XmlHttpRequest in IE. Thanks Simon King #2408
* workaround for MySQLdb imcompatibilty with MySQL 4.1. Thanks to Felix Schwarz
  #2406
* minor code style improvement in quickstart template. #2378
* redirection to default feed in FeedController.index() fixed. Thanks to Florent
  Aide #2374
* fixes for FR locale in JavaScript for CalendarPicker. Thanks to Florent Aide
  #2370
* various test case fixes. Thanks to Christoph Zwerschke, Felix Schwarz 
  #2366 #2374 #2376
* adapt tests to changes in Kid 0.9.4. Thanks to Jeff Hinrichs and 
  Christoph Zwerschke #2364
* reverted #2256 which caused a RuntimeError #2340

*Contributors*

Alberto Valverde, Jeff Hinrichs, Christoph Zwerschke, Felix Schwarz, randall@tnr.cc, sbr77, Florent Aide, Christopher Andt, Simon King, Fred Lin


1.0 (January 03, 2007):
-----------------------

*Changes*

* when used with the --future option, TurboGears can now function without having
  SQLObject installed. #2326
* nose is now an optional setup component #2325
* now possible to pass any option (besides dburi and echo) to sqlalchemy
  engine. Thanks to elftherios and Lee McFadden #2318 #2320
* now possible to place test specific configuration in "test.cfg". Thanks to 
  Tim Freund #2263
* support testing the code that uses identity. Thanks to Max Ischenko and
  Felix Schwarz #2258 #2305
* auto reloading speedup. Thanks to John M. Camara #2256

*Features*

* now possible to add variables to the root template namespace via 
  turbogears.view.root_variable_providers. Thanks Arnar Birgisson #2261
* turbogears.database.run_with_transaction is now a MultiorderGenericFunction to
  allow easier customization. #2226
* tg-admin now accepts --egg and --config as global options which works on all
  commands.

*Fixes*

* Fix implicit transactions for SQLAlchemy. Thanks to Lee McFadden #2322
* Various CSS fixes for DataGrid. Thanks Florent Aide #2316
* FeedController is now a Controller so tg.url works properly and fixed missing 
  import in feed.py .Thanks Florent Aide #2310 #2312
* Looser Enum implementation taht works better with ToscaWidgets #2303
* Kid configuration settings were ignored under certain circumstances. Thanks Joost, Ksenia and Dan for the pathes #2259
* validators.Number handles non-string input gracefully #2254
* nestedVariablesFilter made more robust #2252
* throwing an identity.IdentityException inside a controller method is now
  caught by identity.SecureResource #2250
* various test case fixes. Thanks to Felix Schwarz, Joost Moesker, 
  Jeff Kowalczyk #2247 #2266 #2268 #2314
* 'logout' method in SQLObjectIdentity was setting read-only property. Does not
  suppress exception anymore. #2243


*Contributors*

Alberto Valverde, Joost Moesker, John M. Camara, Dan Jacob, Arnar Birgisson, Ksenia Marasanova, Felix Schwarz, Tim Freund, Max Ischenko, Fred Lin, Florent Aide, Jeff Kowalczyk, elftherios, Lee McFadden, Kevin Dangoor



1.0b2 (November 30, 2006):
---------------------
*Changes*

* The CalendarDatePicker widget allows a validator now.

*Features*

* introduced tgsetup.py which provides simpler installation and better
  error messages. tgsetup.py also provides a --future switch to
  get SQLAlchemy and Genshi for you.

*Fixes*

* SQLAlchemy quickstart projects with identity were missing an import
* SQLObject visit classes can be defined in your model.py
* Fixed a memory usage problem with large file uploads
* Corrected a Python 2.3 compatibility problem
* Identity + SQLAlchemy + PostgreSQL had a problem with timezones that
  has been corrected.
* JSLink now uses <script></script> instead of <script/> to avoid problems
  when used with template languages that don't serialize XHTML->HTML
* A number of fixes and minor enhancements to the quickstart templates
* turbogears.url has a nicer default when you're not running within a
  request (ie when you're in a test)

*Project Updates*

* setuptools 0.6c3

*Contributors*

Fred Lin, Jorge Vargas, Jorge Godoy, Alberto Valverde, Elvelind Grandin,
Lee McFadden, Max Ischenko, Joseph Tate, Matthew Bevan, Roger Demetrescu,
plus some small fixes from several others and a huge amount of
documentation work from Karl Guertin and Adam Jones (in addition to the
other contributors already mentioned).

1.0b1 (September 7, 2006):
---------------------
*Changes*

* The CalendarDatePicker will no longer prefer the user's browser's language
  if a language has been explicitly specified. #1056

*Features*

* Calls to gettext inside kid templates are now detected by i18n.
* Can now pass `tg_format` in the output dict to override the one set by
  expose.
* Can now set the config option `sqlalchemy.echo` to toggle SA's query logging.
* Can now use `field_for` inside `FormFieldContainer`s templates to get child
  fields by name.

*Fixes*

* You can now conveniently use non-ActiveMapper SQLAlchemy classes
  with identity. #1041
* Identity testing is now easier because the `DummyRequest` now
  includes a remote_host.
* Default identity provider will be created if the request doesn't
  have one. #876
* Swedish translation file for the calendar has been fixed #1055
* `testutil.DBTest` will only drop tables that exist #1094
* Added `validate_password` to the SQLAlchemy identity provider
  to match the SQLObject one. #1098
* Corrected spelling at italian CalendarDatePickers' i18n files.
* Fixed a bug with BLOBCols in Model Designer.
* Exceptions raised when SA flushes are now dispatched with TG's errorhandling.
* Can now use `format` (plus other internal named parameters) as a controller's
  method argument name.
* The toolbox will now launch the browser to point to the same port number
  as the server is listening at.

*Project Updates*

* SyntaxHighlighter 1.4.0
* setuptools 0.6c2

0.9a9 (August 17, 2006):
---------------------

*Features*

* tg-admin toolbox now accepts a --conf argument.
* Catwalk now provide some feedback on ajaxcalls
* The quickstarted welcome page are updated and looks much better

*Fixes*

* Adding users with Catwalk should now work
* Admi18n now works with non-ascii translation and html entities


*Project Updates*

* SQLObject 0.7.1dev-r1860
* PasteScript 0.9.7
* ConfigObj 4.3.2
* Nose  0.9
* TurboJson 0.9.9

0.9a8 (July 21, 2006):
----------------------

*Fixes*

* Some problems with the calendar widget that were introduced in 0.9a7
  have been addressed
* Some people have reported getting an SQLObject 0.8 dev package, which
  is not at all tested with TurboGears. The setup file for TurboGears
  will now restrict to < 0.8.

*Project Updates*

* Kid 0.9.3 (addresses problems that people had with comments in base
  templates)
* setuptools 0.6c1


0.9a7 (July 19, 2006)
---------------------

*Backwards Incompatibilities*

* Former LocalizableJSLink is now CalendarLangFile. New LocalizableJSLink is
  simpler but backwards-incompatible.
* Catwalk no longer accepts an allowHost argument. 
  To restrict access to it use Identity.SecureObject instead.
  
*Deprecations*

* Use of "entrys" is now deprecated in the FeedController. You should use
  "entries" instead.
   
*Features*

* Syntax highlighter is used in the widget browser to make the code
  snippets look nice (#843)
* Logging configuration produces better errors and also has access to the
  RotatingFileHandler and TimedRotatingFileHandler (#866, also fixes #820)
* The `validate` decorator now accepts a `state_factory` parameter which should
  be a callable that returns the initial state for validation (the same `state`
  parameter FormEncode validators use). The final state after validation can
  be accessed at `cherrypy.request.validation_state` inside controller methods.
* `tg-admin` commands can state if they need to be run in a project dir.
* Toolbox now uses entrypoints so site-specific tools can be added.
* `tg-admin shell` now asks if it should commit changes to the database on exit.
* Widgets can be listed at the `tg.include_widgets` config. list to send them to
  every template (a la `tg.mochikit_all`). 
* `DBTest` now drops tables after each test so they don't interfere with others.
* Toolbox is now secured using Identity
* SQLAlchemy support not only works again with the latest SQLAlchemy,
  but quickstart works properly and "tg-admin sql create" now works
  for SQLAlchemy databases for the first time.

*Fixes*

* The `sample-prod.cfg` file had an incorrect logging configuration.
* Simplified visit queue handling which solves some mysterious bugs.
* QUICKSTART: `model.py` now includes SQLObject's requirements when identity is
  off.
* `DateTimeConverter` now handles dates < 1900.
* Catwalk now handles gracefully UnicodeCols.
* QUICKSTART: `start-project.py` now detects correct python binary's path in 
  the system.
* Kid's base templates are now (re)loaded properly.
* Config file selection is now smarter.
* `tg-admin update` now finds correct identity provider.
* Catwalk now handles InheritableSQLObjects with mixins gracefully.
* Output encoding wasn't set based on the config value under some
  circumstances (#972)

*Changes*

* If `tg.empty_flash` is True in the app's configuration, then `tg_flash = None`
  will be sent to the template when it's not set. Otherwise it will not be sent
  at all.
* QUICKSTART: Now supports python2.3 with PEAK's [] decorator syntax.
* `DateTimeConverter` validator now raises Invalid('empty') exceptions properly
  and uses the usual `not_empty` parameter. `allow_empty` is deprecated.

*Contributors*

(My apologies if your name belongs here and is not!)

Roger Demetrescu, Elvelind Grandin, Rune Hansen, Sean De La Torre, 
Alberto Valverde, Max Ischenko, Joseph Tate, Elvelind Grandin, 
Charles Duffy, Matt Good, Ksenia Marasanova.

0.9a6 (May 9, 2006)
-------------------

*Backwards Incompatibilities*

* `i18n.runTemplateFilter` in the config file has been renamed
  `i18n.run_template_filter` (#796)
* For people using FastData (experimental): `get_add_url`,
  `get_edit_url` and `get_delete_url` all are passed the row instead
  of the ID now, allowing you to use something other than the ID
  if desired.
* In widgets, if you were using a dictionary as a params be aware that now
  the dictionary is not updated at construction or display/render time but
  simply replaced with the new one. 
  If you were using it to provide default attributes for your widget, take a 
  look at how the TableForm does that.

*Features*

* A new function, `turbogears.util.find_precision`, to tell you
  how many decimal places of precision are required. (To help
  with `i18n.format.format_decimal` which needs to know the
  precision.)
* tg-admin info shows which eggs require TurboGears
* In widgets, SelectionField now supports grouped options, 
  SingleSelectField and MultipleSelectField widgets take advantage of this
  to provide an optgroup tag. The format of a grouped options list is like
  the following:
 
  options = [(None, [(1, "a"), (2, "b")]), ("Others", [(3, "c"), (4, "d")])]

* The Widget Browser now displays the source of the example and the
  template provided by default in the widget (to allow for easier
  complete customization) (#840, #841)
* Tabber and Syntax Highlighter widgets are now included

*Changes*

* sqlite database URIs can now be specified as sqlite:///c:/foo/bar on
  Windows, which is more natural for users. (The sqlite:///c|/foo/bar
  syntax still works.)
* ValueError is raised if an InputWidget contains "." or "-", which are
  reserved for use by the widgets
* Package name is used instead of `your_project` in the quickstart
  logging config.
  
*Fixes*

* QUICKSTART: an exception comes up if a user logs in but is not in
  a group that is required for access. The line with
  `if not identity.current.anonymous and identity.was_login_attempted()`
  in controllers.py or root.py needs an additional
  `and not identity.get_identity_errors()` condition. (#834)
* QUICKSTART: quickstart projects that used identity would generate
  a table called "user", which is invalid for some databases. The
  new quickstart model.py generates tables called `tg_user`. #805
* QUICKSTART: there were problems with the model template for SQLAlchemy
  (#801)
* SQLAlchemy's identity provider was not selected by default when you
  quickstart a new project. (#806)
* Core widgets all include WidgetDescriptions now and appear in the
  Widget Browser in the Toolbox (#727)
* Access logging to a file wasn't working correctly (#816)
* Bug fix for convert/`from_python` for compound and repeating widgets
* User name is now encoded to the DB encoding before a query is run
  in the SQLObject identity provider
* JSLink widgets can now specify a location
* LocalizableJSLink (and the calendar widget) now work in IE (#846)
* Added scheduler to `turbogears.__init__.__all__` so that references
  to it work properly.
* tg-admin info and Toolbox info commands now work properly and show
  the same information.
* Fixed a serious bug in Python 2.3 compatibility (#853)

*Project Updates*

* MochiKit updated to 1.3.1 (#804)

*Contributors*

Max Ischenko, Claudio Martinez, Matt Good, Rune Hansen, Michele Cella,
Jorge Godoy, Alberto Valverde González, Simon Belak, Jeroen Dekkers,
Mark Ramm-Christensen, Ronald Jaramillo, 
Richard Standbrook, Roger Demetrescu, Patrick Lewis, Hal Wine,
Jorge Vargas, Bob Kuehne.

0.9a5 (April 26, 2006)
----------------------

*Backwards Incompatibilties*

* An identity login form must have a submit button having the name
  specified in the config file (identity.form.submit).  If you have a
  commented identity.form.submit value and used the default login.kid
  file, you will need to add 'name="login"' to the login.kid submit
  button.
* In widgets, the base Widget class no longer supports a validator.
  If you need a validator you should use the InputWidget class
* In widgets, the display and the adjust_value methods have a slightly
  different signature (if you happen to use the "convert" parameter,
  you just need to use it as a keyword parameter and not a
  positional one.)
* decorator() should be applied to the function accepting the function
  being decorated ("entangle" by convention), not the caller.
* Removed keyword argument "argsink" from decorator(),
  weak_signature_decorator() should be used instead.

*Deprecations*

* In widgets, template_vars in widgets are now called "params" and
  options_for has been renamed params_for
* In widgets, the update_data method has been renamed update_params
* Identity has moved to PEP8 style naming. Changed userId, groupId, and
  permissionId to be user_name, group_name, and permission_name.
* visit_id has been deprecated in favor of visit_key
* SQL scripts to migrate PostgreSQL and MySQL identity databases are
  available (http://trac.turbogears.org/turbogears/ticket/737)


*Features*

* Dramatically improved and unified logging configuration. Config files
  can now use the options in Python's logging module for log formats
  and output.
* TurboGears now includes an enhanced version of Irmen de Jong's
  Kronos scheduler, allowing you to schedule tasks that run in
  separate threads or processes periodically.
* For Python 2.3 users, there is a convenient new decorator syntax
  that comes from Phillip Eby's PEAK.
  
Here's is the equivalent of @expose():

    [expose()]
    def index(self):
        pass

* Added a new turbogears.start_server function which will help ease
  the transition to 1.1 *and* adds the ability to use Ian Bicking's
  EvalException. You must turn on tg.fancy_exception to use it
  at this point.
* In widgets, if the widget you are using provides a default validator,
  for example a SelectionWidget, you can tweak its parameters
  by just passing a dictionary of those parameters as validator
  (for example, validator=dict(not_empty=True))
* In widgets, every attribute listed inside params now supports callables
  automatically (the attribute will be called for computation at request
  time)
* Some improvements to the ImageButton widget
* More customization hooks for CheckBoxList, RadioButtonList, TableForm
  and ListForm
* Decimals are properly jsonified (#472)
* datetime.date instances are properly jsonified (#759)
* Commas are supported in number validation (#720)
* It's now possible to determine what permissions are required for
  a given controller method (#603)

*Changes*

* Identity model classes are now placed directly into the model.py of
  a quickstarted project. This new setup is much easier to change,
  since requirements for the identity model vary dramatically. Another
  advantage is that quickstart projects that don't need identity
  start off with cleaner code, and projects that do need identity
  need almost no additional configuration or setup.
* quickstart projects include a "json.py" file as a home for JSON
  view code.
* i18n "scan" command has been changed to "collect" to match the
  admi18n Toolbox tool
* If you quickstart a project while in an svn checkout, files are no
  longer automatically "svn add"ed. This corrects some problems that
  people ran into with that behavior.
* The "prod.cfg" file in quickstart projects is now called
  "sample-prod.cfg" to reflect that it is just used as a sample that
  you copy to your real production servers (#762).
* The various classes used to make dictionaries look like normal
  objects have been replaced by turbogears.util.Bunch (#779)

*Fixes*

* Model Designer can now handle joins to the same table (#769)
* Unicode values sent to the turbogears.url function are utf8 encoded.
* NotEmpty validator works with CheckBoxList now. (#696)
* Grid widget's css has been improved to not interact with other
  widgets (#729, thanks to mark@cyberware)
* the "self" parameter is no longer accidentally removed by validation
* tg_format is properly stripped out for JSON requests (#740)
* calendar widget language fixes (many language files needed patching)
* DataController's float columns are properly converted (#707)
* str values in Kid templates are now assumed to be utf8 rather than
  ASCII (changeable via kid.encoding) (#743)
* The flash message set on the current request takes precedence over the
  one in the cookie (#747)
* py:match was being used in the default templates in a way that would
  drop the text from the first node. (#785)
* AutoCompleteField widget's only_suggest now works correctly when
  there is only one item listed (#750)
* Lots of HTML cleanup

*Project Updates*

* TurboGears now uses ConfigObj 4.3.0 for configuration
* MochiKit upgraded to 1.3
* simplejson upgraded to 1.3
* CherryPy upgraded to 2.2.1
* Kid upgraded to 0.9.1
* FormEncode upgraded to 0.5.1
* PasteScript upgraded to 0.5.1

*Contributors*

Alberto Valverde González, Jeff Watkins, Max Ischenko, Michele Cella,
Simon Belak, Jorge Godoy, Patrick Lewis, Jorge Vargas, Joost Moesker,
Joseph Tate, Philip Walls, Bob Ippolito, Steve Bergman, Andrey Lebedev,
Brian Beck, Roger Demetrescu.


0.9a4 (April 5, 2006)
---------------------

*Features*

* TableForm and ListForm both have new CSS classes "tableform" and
  "listform" and also have odd/even classes for the rows.

*Fixes*

* The 0.9a3 quickstart template was missing important __init__.py
  files in the distributed egg.

0.9a3 (April 4, 2006)
---------------------

*Changes*

* FastData is no longer included with the TurboGears core package. You can
  install it with TurboGears by easy_install-ing "TurboGears[exp]" instead
  of "TurboGears".

*Features*

* You can find out if login was attempted during this request by calling
  `identity.was_login_attempted`
* Added tg.strict_parameters option that will cause an exception to be
  raised if extra parameters are passed to a controller method. #694

*Fixes*

* Base template (eg "master.kid") now reload automatically when changed
  (#55)
* identity.Any was missing an `error_message` attribute (#667)
* Identity provides a more explicit error about wrong username/password
  (#616)
* CatWalk no longer has a problem changing more than one foreign key
  label in "manage columns" (#690)
* plain_gettext is now exported from the i18n package.
* DataGrid.column fields are supported by FastDataGrid (#706)
* The tg_errors variable sent to a controller now has the correct value
  even if the controller method doesn't have keyword arguments. #698
* DBURIs with notrans_ now work properly with tg-admin sql create. #702
* Dutch and German calendar translations have been fixed #700.

*Project Updates*

* setuptools 0.6a11
* CherryPy 2.2.0
* SQLObject to 0.7.1dev-r1675

*Contributors*

This update brought to you by Michele Cella, Jeff Watkins, Simon Davy,
Baruch Even, Simon Belak, Claudio Martinez, Max Ischenko, Jason Chu,
Roger Demetrescu, Joost Moesker, plus Phillip Eby for setuptools
and Remi Delon and the others working on CherryPy.

0.9a2 (March 27, 2006)
----------------------

*Backwards Incompatibilities*

* Due to Python 2.3 issues and some additional discussion, the config
  files have gone back to an INI-style format. This means that some
  minor changes are needed if you were using the 0.9 ".py" config files,
  but no changes are required for people using 0.8 ".cfg" config files.
  See the upgrading guide for details.
* If you used CompoundWidgets in 0.9a1, "widgets" has changed to
  "member_widgets".
* If you are using a Form or a FieldSet widget you must explicitly pass
  the "fields" parameter, the first positional parameter expected
  since 0.9a2 is "name".
* If you are using a Form or a FieldSet widget with a custom template
  you must update your template accordingly to the new templates
  TG is using.

*Deprecations*

* WidgetsDeclaration (introduced in 0.9a1) has been renamed WidgetsList
  for clarity.
* turbogears.config now has get() and update() functions that should
  be used in place of their cherrypy.config counterparts. This change
  was made knowing that there will be more powerful, TurboGears-specific
  configuration in TurboGears 1.1.
* The field\_for method of a Form (introduced in 0.9a1) has been
  deprecated and it's use is highly discouraged and error prone,
  use display\_field\_for or render\_field\_for instead.
* In the turbogears.view module variableProviders has been renamed
  variable_providers.
* turbogears.fastdata.formmaker's sqlwidgets function (introduced in
  0.9a1) has been renamed fields_for.

*New Features*

* Controller methods can now have multiple expose() decorators, allowing
  you to define different output formats (even with different template
  engines) that can be chosen via tg_format or the Accept header.
* New AjaxGrid widget provides a grid in JavaScript that is populated via
  an Ajax call.
* Three new base widgets to manage forms have been introduced:
  CompoundFormField, RepeatingFormField and FormFieldsContainer.
* Experimental support for SQLAlchemy. For more complicated databases
  or certain database requirements, SQLAlchemy handles the database more
  gracefully. The main database layer for TurboGears remains SQLObject
  and SQLObject is more fully supported within TurboGears. However,
  for those who need it, SQLAlchemy support is there.
* display\_field\_for and render\_field\_for are automatically added to the
  template scope of any FormFieldsContainer widget and can be used to
  easily display/render a field with the corrects value and options.
* The basis for creating repeating sets of widgets has been created
  (see RepeatingFormField and RepeatingFieldSet for an example)
* Catwalk can filter the data you see
* When using widgets, you can now have more than one form on a page
  while retaining validation sanity.
* With widgets, required fields automatically get a CSS class
* CompoundWidgets/Forms now use FormEncode schemas, which provide
  a number of additional validation options.
* AutoCompleteFields can now pass an ID back to the server when
  submitted (instead of just passing the matching search string).
* quickstart includes a "release.py" file where you can put your
  project information (including version number). This is the
  safe mechanism for allowing your project itself to access the
  version number while your setup script also has access to the
  same information (Don't Repeat Yourself)
* quickstart has a new "tgbig" template designed for larger projects.
  This adds a controllers package to the basic TurboGears template.
* CSSLink and CSSSource widgets now support "media"
* The AutoCompleteField now has an "only_suggest" flag which makes
  it so that the first item on the list is not automatically submitted
  when you press return. This is useful for search boxes (as opposed
  to data entry fields).
* The turbogears.startup now contains call_on_startup and call_on_shutdown
  lists. You can append callables to these to have them executed at
  the right time.
* If you are using the i18n support, the _ function (alias of the
  gettext function) is now properly mapped to lazy_gettext if
  needed, this means you can use "_" for everything.
* Added LocalizableJSLink widget that allows scripts to be chosen based
  on the user's locale.

*Changes*

* log\_debug\_info\_filter is now turned off by default (this is the
  CherryPy filter that lists the request time). This filter causes
  problems with things like JSON output. You can still turn it
  back on via the config file.
* Unless you specifically configure the decodingFilter yourself,
  TurboGears will automatically turn on CherryPy's decodingFilter
  (expecting utf-8 input).
* cherrypy.lowercase_api is set to True in new quickstarted projects.
  This should result in a performance boost, and requires that you use
  PEP 8 style names when calling CherryPy APIs/config values.
* Table forms now use TH tags for the field labels, making it easier to
  apply appropriate styling to the tables.
* AutoConnectHub used to support a "processConnection" (something it
  inherited from SQLObject). This is not really a supported model of
  operation, so it has been removed. If you do want to work that way,
  use SQLObject's own ConnectionHub class.
* The test_model test has been commented out from the quickstart template,
  because some projects don't have databases.


*Fixes*

* The TextArea widget now posts properly within a RemoteForm.
* Catwalk styling cleanup
* Catwalk no longer has problems with empty tables with foreign keys
* ForEach validator added to turbogears.validators namespace
* Catwalk will show related joins in the edit view
* SQLObject identity provider passwords are automatically encrypted
  (this was in 0.9a1). This didn't work properly when identity wasn't
  fully running (as in the tg-admin shell). This has been fixed.
* The AutoCompleteField turns off the browser's own autocompletion.
* A nicer error message is provided if you return something other
  than a string or a dict from your controller method.
* admi18n does a better job of grouping files in the correct folder
  when collecting strings and skips over folders like ".svn".
* The turbogears.url() function was flipping around path elements
  in the application root. Applications roots are not commonly used
  right now, but this was noticeable if you used the FeedController.
* Various fixes for CatWalk's database access (see tickets
  #568, #249, #213, #618)
* ModelDesigner and admi18n can find your model.py file even if you
  change your package name at quickstart time.

*Project Updates*

* Kid 0.9 / TurboKid 0.9.2
* CherryPy 2.2.0rc1
* PasteScript 0.5
* TurboGears' JSON output now comes from the TurboJson plugin

*Contributors*

This release comes to you thanks to the work of Michele Cella,
Elvelind Grandin, Ronald Jaramillo, Simon Belak, Jeff Watkins,
Alberto Valverde González, Jason Chu, Owen Mead-Robins,
Dan Weeks, Dennis Brakhane, Heikichi Umahara, Patrick Lewis,
Joost Moesker, Roger Demetrescu, Liza Daly.

0.9a1 (February 23, 2006)
-------------------------

*Backwards Incompatibilities*

* turbogears.expose no longer provides JSON by default. You need to
  turn on JSON via the config file or by the allow_json parameter
  to expose.
* The server.webpath configuration variable will not only properly set
  outgoing URLs, but will also "fix" incoming URLs if TurboGears is
  running as some path underneath another webserver. If you were
  previously running a CherryPy filter to handle this, you no longer
  need to.
* Directories of static files need an absolute path. The new configuration
  file format makes it easy to provide an absolute path without
  truly being tied to that path.
* Previously, if you were using a FormEncode Schema for validation for
  an exposed method, validation would fail if a value was missing but
  the method had a default value for that parameter. Now, if that value
  is missing, the method will get called with the default just as it
  is normally called in Python.

*Deprecations*

* In templates the "std" object that holds common values and functions
  has been changed to "tg".
* turbogears.controllers.Root has now become
  turbogears.controllers.RootController for clarity's sake. Root
  continues to work, but its use is deprecated.
* Error handling has been greatly improved. Use of the validation_error
  method has been deprecated. It will still be called if it
  exists, but a DeprecationWarning will be displayed.
* turbogears.tests.util has been moved to turbogears.testutil
* CherryPy has switched to PEP8-style names for things. The old names
  still work. However, they are deprecated.
* expose(html=.. is now deprecated in favor for expose(template=..
* the old config file format is deprecated in favor of the new Python
  module format.

*Features*

* The TurboGears Toolbox wraps a number of useful tools in one web
  interface. The toolbox can be extended with additional tools. Run
  the Toolbox with tg-admin toolbox.
* CatWalk model/database browser is now part of the TurboGears Toolbox.
  Thanks to Ronald Jaramillo.
* There's a new "widgets" package that lets you easily create forms
  with sophisticated and dynamic behavior, all built from reusable
  components.
* Identity management and access control now provided via
  turbogears.identity module. Includes basic classes for User, Group,
  and Permission objects via turbogears.identity.model. Thanks to
  Jeff Watkins.
* There is a new internationalization package that allows you to use
  to conveniently localize your application via gettext. Thanks to
  Dan Jacob.
* Internationalization can be managed via the Toolbox (thanks to
  Ronald Jaramillo) or the command line (thanks to Max Ischenko).
* Each request is implicitly wrapped in a Transaction. This solves
  caching issues and reduces boilerplate code. It also helps codify
  a best practice so that bad data does not end up in your database.
* Error handling for a method can be specified with an error_handler
  decorator thanks to Simon Belak.
* TurboGears now has a feed object that can generate rss2.0, atom0.3
  and atom1.0 feeds
* Template encodings other than utf-8 can be selected with the new
  kid.encoding variable
* tg-admin now uses PasteScript and can now supports user specific templates
* tg-admin now have a update command
* TurboGears is now compatible with Python 2.3, thanks to Paul Clifford.
* TurboGears supports plugins for template engines, tg-admin commands
* A plugin for Cheetah templates has been released separately
* TurboGears now uses nose for testing
* Templates can now be specified relative to the current package by
  preceding the template name with ".". For example, if you have a
  controller in "yourpackage" with templates in a package under that
  package, you can use "yourpackage.templates.templatename" *or*
  ".templates.templatename". Thanks to David Bernard.
* New commands can be added to tg-admin via the turbogears.command
  entry point. Thanks to Elvelind Grandin.
* Controllers that subclass controllers.Controller (including the
  standard RootController) can automatically use positional
  parameters for the methods. This means that "/entry/MONTH/DAY/YEAR"
  can be interpreted easily by a method entry(self, month, day, year).
* MochiKit can now be included in your final HTML output by putting
  turbogears.mochikit in your output dictionary (it doesn't matter
  what the key assigned is). The advantage to doing this is that it
  helps to ensure that MochiKit is included only once, even if you're
  using widgets that require it.
* MochiKit can be enabled everywhere by setting tg.mochikit_all to
  True in your config file.
* Added new "cycle" object to std in template usage. This makes it
  easy to cycle through a number of values (and it also lets you
  retrieve the current value). This is useful for things like
  even and odd row classes, etc. Thanks to Karl Guertin.
* You can send a random value in to the controller (tg_random) that
  will be automatically thrown out to get around issues with
  Internet Explorer caching data too aggressively.
* The expose decorator has been split into input and output functions.
  expose continues to handle output, and the new validate decorator
  handles input (validation and form handling). This new setup makes it
  easier to mix in your own decorators if you need to.
* Added turbogears.redirect which wraps the cherrypy.HTTPRedirect
  exception to automatically call turbogears.url to help ensure
  properly formatted URLs. You can either call turbogears.redirect
  or "raise turbogears.redirect" if that makes the intent clearer
  to you (as happens with the existing usage of cherrypy.HTTPRedirect)
* There is a new configuration file format that are slightly specialized
  Python modules. This allows you to run Python code to determine your
  configuration.
* You can now specify that you're generating a fragment of a page
  (rather than an entire page) at expose time by passing
  fragment=True in to expose. This is useful if you want Kid to
  generate part of a page for an XMLHttpRequest, for example.
* There's a new validator, JSONValidator, that reads/writes JSON,
  which is convenient for parameters that are coming in via JSON.
* new test stuff (expand)
* There is now a tg-admin info command that shows all the version info for the tubogears components.
* TurboGears now supports SQLAlchemy -- the unit-of-work is committed after
  a successful controller request. You can use the PackageEngine to load a
  dburi based on your package or the default sqlalchemy.dburi.

*Fixes*

* setup.py tests for Python 2.4 (thanks to Elvelind Grandin for the
  idea and Bob Ippolito for the simplest implementation possible)
* base templates reload automatically (thanks to David Stanek) - NOTE
  this ticket has been reopened ******************
  support for this is experimental until the issues are ironed out.
* Kid no longer puts blank space in textareas.
* turbogears.flash handles unicode values properly

*Project Updates*

* replaced json-py with Bob Ippolito's simple_json
* the RuleDispatch package is new to TurboGears
* TurboGears has moved to CherryPy 2.2, which is not yet stable. We will
  use the most stable snapshots possible in TurboGears 0.9 releases.
* MochiKit upgraded to 1.2
* setuptools upgraded to 0.6a10

*Contributors*

The following people made this release possible:

Elvelind Grandin, Ronald Jaramillo, Jeff Watkins, Dan Jacob, David Stanek,
Jared Kuolt, Paul Clifford, Lee McFadden, Michele Cella, Karl Guertin,
Max Ischenko, Mark Godfrey, Simon Belak, Jorge Godoy, Patrick Lewis,
Joey Smith, David Bernard, Simon Davy, Gary Godfrey, Jason Chu,
Liza Daly, Ryan Forsythe, Jeremy Jones, Egor Cheshkov, Claudio Martinez,
Leandro Lucarella, Bob Ippolito, Alberto Valverde González,
Brian Bockelman, Stephen Thorne, Robin Bryce, Ksenia Marasanova,
Ori Avtalion, Martina Oefelein, Ian Bicking, Rick Richardson,
Luis Bruno, Joost Moesker, BJörn Lindqvist.

A special thanks to Cliff Wells of Develix for sponsoring a bug bounty!

0.8.9 (February 6, 2006)
------------------------

* Fixes a warning message that appears with each quickstart

0.8.8 (January 10, 2006)
------------------------

* A security flaw was discovered in CherryPy's static filter. This
  TurboGears update changes the CherryPy requirement to 2.1.1.


0.8.7 (January 4, 2006)
-----------------------

This update primarily solves installation issues and is not required
otherwise.

* quickstart corrected to properly produce egg-info directories
  (previously, directories could be created with "-" when it should
  have a "_"). Note that setuptools 0.6a9 will warn you if you have
  a - in your egg-info directory name. Just rename the directory,
  and you'll be fine.
* Installation issues that people may have had earlier are resolved
  in this setuptools update.
* version number set to 0.8.7 to reflect that this is considered the
  "stable" version of TurboGears vs. the current 0.9 code in svn.

*Project Updates*

* setuptools 0.6a9
* sqlobject 0.7.1dev_r1457 (updated to handle the setuptools change,
  but also includes other bugfixes)


0.8a6 (December 26, 2005)
-------------------------

* Chained validators will now cause an Invalid exception to be raised
  as appropriate.
* When validation would fail, previously an unexpected exception may
  be raised when an Invalid exception is expected
* quickstart didn't look out for .pyo files in the same way that it did
  .pyc files.

*Project Updates*

* json-py updated to 3.4

0.8a5 (December 2, 2005)
------------------------

* setup has been changed to ensure that people properly
  get the CherryPy 2.1 release version.

*Project Updates*

* Kid updated to 0.8.0
* MochiKit updated to 1.1
* FormEncode updated to 0.4
* setuptools updated to 0.6a8


0.8a4 (October 25, 2005)
------------------------

*Project Updates*

* setuptools 0.6a6
* CherryPy 2.1 final
* MochiKit 1.0

*Fixes*

* On some servers, TurboGears can take a minute to start answering
connections due to the way the OS handles incoming connections to
ports that have nothing listening on them.


0.8a3 (October 16, 2005)
------------------------

*Fixes*

* setup.py was not using setup_requires in a productive way. This has
  been changed, so tg-admin quickstart will no longer need to
  go to the internet to function.
* turbogears.database.set_db_uri was not properly putting the setting
  in the global config section. By Robert Leftwich.
* some people have had trouble with the url function not being able to
  find cherrypy.request.approot. This may be due to older classes that
  do not extend controllers.Root. This was not listed as a
  requirement for the URL function. The documentation for the
  url function has been updated, and the code has been updated
  to always set the approot to the top of the site at least.

0.8a2 (Oct 14, 2005)
--------------------
*Fixes*

* tg-admin quickstart was missing the appropriate egg-info for the sql
  commands to work properly

0.8a1 (Oct 12, 2005)
--------------------

*Backwards Incompatibilities*

* All of the "turbogears*" variables have been changed to "tg_*". These
  are tg_template, tg_format, tg_flash and tg_js. (Note that
  turbogearsfmt has become tg_format and turbogearshtml has become
  tg_template.)
* The StringBoolean validator (which has moved into FormEncode proper)
  now returns strings for from_python. For example, from_python(True)
  now returns 'true'. It used to return True.
* turbogears-admin.py is now called tg-admin and is automatically
  generated by setuptools
* The tg-admin sql commands now require a properly setup .egg-info
  directory to automatically find the model classes. If the egg info
  is not properly set up, the command can fix it automatically.
* The view.render method's "html" parameter has been renamed "template"
  to reflect that the templates might be for XML presentations. Most
  people don't call view.render directly.

*New Features*

* There is a new PackageHub that is designed to allow different parts
  of a site to use different databases. Use of the PackageHub works
  just like the AutoConnectHub.
* Added a new function: turbogears.database.set_db_uri. This is a
  more pleasant wrapper around the cherrypy config variables that
  can be used in command line tools and the like.
* IPython is used in tg-admin shell, if it's available. By David Guaraglia.
* You can specify a default format via the new format parameter
  to expose. For example, expose(format="json") will cause the
  method to output JSON by default, even if HTML is available.
  By Elvelind Grandin.
* You can specify the Content-Type via expose. Example:
  expose(content_type="text/javascript"). By Elvelind Grandin.
* expose now has a "template" parameter that can be used in place
  of "html". This is more pleasant for non-HTML applications.
* On Macs, if you're running in development mode the server will
  be advertised via Bonjour. If you enable Bonjour bookmarks
  (via the Bookmarks Preferences tab in Safari), you'll see your
  development server show up automatically. By Bob Ippolito.
* There is now a url function that can be used to generate URLs
  conveniently and, more importantly, with an appropriate view
  of where the root of the web application is.
* validators can now be specified with a dict (the 0.5 way) or with a
  FormEncode Schema, which provides more options. By Fabian Neumann.
* Quickstart now provides a basic static files skeleton. By
  Elvelind Grandin.
* Added config setting to determine Kid's output format (HTML/XHTML).
  By Fabian Neumann.
* In quickstart, project-start.py now takes a config file on the
  command line. By Elvelind Grandin.
* project-start.py is also made executable automatically. By
  Fabian Neumann.
* Added turbogears.tests.util.call function to allow you to call a
  controller method and get the dictionary back without processing
  to HTML or JSON. This allows you to test controller logic independent
  of presentation.

*Project Updates*

* setuptools updated to 0.6a5
* SQLObject updated to 0.7 final
* FormEncode updated to 0.2.3dev-r1108
* CherryPy updated to 2.1-rc2
* MochiKit updated to 0.9
* Kid updated to 0.7adev-r186

*Notable Improvements in the Projects*

Kid can now generate plain text output using the PlainSerializer.

_Fixes_

* All of the sqlobject-admin commands now work through the use of
  egg metadata.
* If a template was specified in the returned dictionary from an
  exposed method, but not in the parameters to expose itself,
  that template was not applied. By Ronald Jaramillo.
* The content-type meta tag in the quickstart files is now automatically
  stripped out, because Kid's HTML serializer puts one in.
* Improved comments in the quickstart config files.
* There is a temporary hack to handle threadsafety issues with sqlite.
  This has been changed to *only* affect sqlite.
* JSON output should work for Opera now (Opera appeared to have a
  problem with the text/javascript content-type and utf-8 encoding.)
  By "Lethalman".
* All files needed for a project to install and run from an egg should
  be installed properly based on the quickstart setup script.
* The flash cookie was not always deleted. Setting the path on the
  cookie corrected this. By Nick.

0.5.1 (Sep 17, 2005)
--------------------

Relaxed version requirements and changed version numbering for
included ElementTree packages to ease installation troubles


0.5.0 (Sep 17, 2005)
--------------------

* Initial public release.
